﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Management;
using System.Text;
using System.Windows.Forms;

namespace DojoNorthSoftware.Classic.HomeServerSMART.Components.UI.UserControls
{
    public partial class HelpAbout : Form
    {
        private String expiration;
        private bool useDefaultSkinning;
        
        public HelpAbout(bool defaultSkinning)
        {
            InitializeComponent();
            expiration = String.Empty;
            //expiration = " (Expires: " + License.GetExpirationDate().ToString() + ")";
            useDefaultSkinning = defaultSkinning;
        }

        private void HelpAbout_Load(object sender, EventArgs e)
        {
            String title = OperatingSystem.IsWindowsServerSolutionsProduct(this) ? Properties.Resources.ApplicationTitleHss : Properties.Resources.ApplicationTitleWindowSmart;
            if (!useDefaultSkinning)
            {
                panel1.BackgroundImage = Properties.Resources.HelpAboutSBS;
            }
            this.Text = "About " + title;
            label1.Text = title;
            labelVersion.Text = "Version " + System.Reflection.Assembly.GetExecutingAssembly().GetName().Version.ToString() + expiration;

            groupBox1.Text = "System Info";
            labelEntity.Text = "Windows Home Server \"v1\"";
            labelEmail.Text = Environment.OSVersion.VersionString;
            labelRestrictions.Text = "Licensed for Non-Commercial & Commercial Use";
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Credits creds = new Credits();
            creds.ShowDialog();
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
            Utilities.Utility.LaunchBrowser(Properties.Resources.ResourceUrlAsp);
        }
    }
}
