﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.HomeServer.Extensibility;
using Microsoft.HomeServer.SDK.Interop.v1;

using DojoNorthSoftware.Classic.HomeServerSMART.Components;
using DojoNorthSoftware.Classic.HomeServerSMART.Components.UI.UserControls;
using Gurock.SmartInspect;

namespace Microsoft.HomeServer.HomeServerConsoleTab
{
    public class HomeServerSmartConsole : Microsoft.HomeServer.Extensibility.IConsoleTab
    {
        // Private fields declared
        private IConsoleServices services;
        // Declare an instance of the UserControl, ShowWHSInfoPanel
        private SmartDiskInfo nPanel;
        private WHSInfoClass whsInfo;

        // The constructor
        public HomeServerSmartConsole(int width, int height, IConsoleServices consoleServices)
        {
            // Initialize the logging
            String path = String.Empty;
            SiAuto.Si.Connections = "file(filename=" + DojoNorthSoftware.Classic.HomeServerSMART.Components.Utilities.Utility.GetLogFileName(
                Properties.Resources.LogfilePrefix, Properties.Resources.LogfileExtension, out path) + ")";
            SiAuto.Si.Enabled = DojoNorthSoftware.Classic.HomeServerSMART.Components.Utilities.Utility.IsLogEnabled();

            // Initialize the private fields
            nPanel = new SmartDiskInfo();
            nPanel.Size = new Size(width, height);
            //nPanel.consoleToolBarButton5.Click += new EventHandler(BtnSettings_Click);
            this.services = consoleServices;
            whsInfo = new WHSInfoClass();
        }

        internal void BtnSettings_Click(object sender, EventArgs e)
        {
            //this.services.OpenSettings(this.SettingsGuid);
        }

        public string TabText
        {
            get
            {
                return Properties.Resources.ApplicationTitle;
            }
        }

        public Bitmap TabImage
        {
            get
            {
                return Microsoft.HomeServer.HomeServerConsoleTab.Properties.Resources.DiskHeartbeat32x32;
            }
        }

        public Control TabControl
        {
            get
            {
                return nPanel;
            }
        }

        public bool GetHelp()
        {
            // Open a custom compiled Help file (.chm)topic
            //this.services.OpenHelp("HomeServerSMART.chm", Properties.Resources.HelpGuid);
            Help.ShowHelp(this.nPanel, "HomeServerSMART.chm");
            return true;
        }

        public Guid SettingsGuid
        {
            get
            {
                return new Guid(Properties.Resources.SettingsGuid);
            }
        }
    }
}
