﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.HomeServer.Extensibility;

namespace Microsoft.HomeServer.HomeServerConsoleTab
{
    public class HomeServerSettingsExtender : Microsoft.HomeServer.Extensibility.ISettingsTab
    {
        //private SampleControl tabControl;
        private SettingsControl tabControl;
        private IConsoleServices services;

        //The constructor
        public HomeServerSettingsExtender(int width, int height, IConsoleServices consoleServices)
        {
            //Initialize private fields
            //tabControl = new SampleControl(width, height);
            tabControl = new SettingsControl();
            this.services = consoleServices;
        }

        public string TabText
        {
            get
            {
                return Properties.Resources.ApplicationTitle;
            }
        }

        public Bitmap TabImage
        {
            get
            {
                return Microsoft.HomeServer.HomeServerConsoleTab.Properties.Resources.DiskHeartbeat32x32;
            }
        }

        public Control TabControl
        {
            get
            {
                return tabControl;
            }
        }

        public bool GetHelp()
        {
            // Open a custom compiled Help file (.chm)topic
            //this.services.OpenHelp("HomeServerSMART.chm", Properties.Resources.HelpGuid);
            Help.ShowHelp(this.tabControl, "HomeServerSMART.chm");
            return true;
        }

        public Guid SettingsGuid
        {
            get
            {
                return new Guid(Properties.Resources.SettingsGuid);
            }
        }

        public bool Commit()
        {
            return false;
        }

        public void LinkLabelDonation_Click(object sender, EventArgs e)
        {
            try
            {
                this.services.OpenUrl(Properties.Resources.ResourceDonationUrl);
            }
            catch
            {
            }
        }

        public void LinkLabelUrl_Click(object sender, EventArgs e)
        {
            try
            {
                this.services.OpenUrl(Properties.Resources.ResourceUrl);
            }
            catch
            {
            }
        }
    }
}
