﻿using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Text;

namespace DojoNorthSoftware.HomeServer.HomeServerSMARTService.Enumerator
{
    [StructLayout(LayoutKind.Sequential)]
    public struct SMART_DATA
    {
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 512)]
        public byte[] Data;
    }

    [StructLayout(LayoutKind.Sequential)]
    public struct SMART_DATA_UCHAR
    {
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 512)]
        public byte[] Data;
    }

    [StructLayout(LayoutKind.Sequential)]
    struct SMART_DATA_SII
    {
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 512)]
        public byte[] VendorSpecific;
        public byte FailurePredicted;
    }

    [StructLayout(LayoutKind.Sequential)]
    struct ATA_SMART_INFO
    {
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 512)]
        public byte[] SmartReadData;
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 512)]
        public byte[] SmartReadThreshold;
        UInt32 AttributeCount;
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 30)]
        SMART_THRESHOLD[] Threshold;
    };

    [StructLayout(LayoutKind.Sequential)]
    struct SMART_THRESHOLD
	{
		public byte Id;
		public byte ThresholdValue;
		[MarshalAs(UnmanagedType.ByValArray, SizeConst = 10)]
        public byte[] Reserved;
	};

    enum SMART_QUERY_RESULT
    {
        SMART_QUERY_RESULT_OK = 0,
        SMART_QUERY_INVALID_HANDLE,
        SMART_QUERY_IO_CONTROL_FALSE,
        SMART_QUERY_OUTDATA_SIZE_MISMATCH,
        SMART_QUERY_EXCEPTION,
        SMART_QUERY_PENDING
    };

    public enum COMMAND_TYPE
    {
        CMD_TYPE_PHYSICAL_DRIVE = 0,
        CMD_TYPE_SCSI_MINIPORT,
        CMD_TYPE_SILICON_IMAGE,
        CMD_TYPE_SAT,				// SAT = SCSI_ATA_TRANSLATION
        CMD_TYPE_SUNPLUS,
        CMD_TYPE_IO_DATA,
        CMD_TYPE_LOGITEC,
        CMD_TYPE_JMICRON,
        CMD_TYPE_CYPRESS,
        CMD_TYPE_PROLIFIC,
        CMD_TYPE_DEBUG
    };
}
